#include <algorithm>
#include <cstdint>
#include <iostream>
#include <istream>
#include <vector>

using ll = int64_t;
const ll maxn = 100+5;
ll n,p,ans{};
std::vector<ll> a;

void cycle(ll bit){ //should be 128bit
    ll sum{};
    for(ll i=1;i<=n;i++){
        if((1<<(i-1))&bit){
            sum=(sum+a[i])%p;
        }
    }
    ans=std::max(ans,sum);
}

int main(){
    a.resize(maxn);

    std::iostream::sync_with_stdio(false),std::cin.tie(nullptr),std::cout.tie(nullptr);
    std::cin>>n>>p;

    for (ll i=1;i<=n;i++) {
        std::cin>>a[i];
        a[i]%=p;
    }

    for(ll i=1;i<(1<<n);i++){
        cycle(i);
    } 

    std::cout<<ans<<'\n';
}